VERSION 5.00
Begin VB.UserControl PersistentCollection 
   BackColor       =   &H008080FF&
   ClientHeight    =   720
   ClientLeft      =   0
   ClientTop       =   0
   ClientWidth     =   855
   ScaleHeight     =   720
   ScaleWidth      =   855
End
Attribute VB_Name = "PersistentCollection"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit
'
Private Declare Sub CopyMemory Lib "kernel32" Alias "RtlMoveMemory" (ByRef pDest As Any, ByRef pSource As Any, ByVal ByteLen As Long)
'
Dim coll As New Collection
Dim idx As Long
'

Private Sub UserControl_Initialize()
    idx = 1
End Sub

Private Sub UserControl_WriteProperties(PropBag As PropertyBag)
    Dim sKeys() As String
    Dim sData() As String
    Dim bb() As Byte
    Dim i As Long
    Dim s As String
    '
    ' Collections don't support persistence, so we do it the hard way.
    '
    If coll.Count <> 0 Then
        '
        ' Get an array of keys/indexes and data.
        sKeys = CollKeys                        ' Get all keys.
        ReDim sData(coll.Count - 1)
        For i = 0 To UBound(sKeys)              ' Get all data into an array, based on keys.
            sData(i) = coll.Item(sKeys(i))
        Next i
        '
        ' Serialize the keys into a byte array and write to property bag.
        s = Space$((UBound(sKeys) + 1) * 8)
        For i = 0 To UBound(sKeys)
            Mid$(s, i * 8 + 1, 8) = Right$("0000000" & Hex$(CLng(sKeys(i))), 8)
        Next i
        bb = StrConv(s, vbFromUnicode)
        PropBag.WriteProperty "collKeys", bb
        '
        ' Serialize data and write to property bag.
        s = Join(sData, vbNullString)
        PropBag.WriteProperty "collData", s
        '
        ' Serialize data lengths and write to property bag.
        s = Space$((UBound(sData) + 1) * 8)
        For i = 0 To UBound(sData)
            Mid$(s, i * 8 + 1, 8) = Right$("0000000" & Hex$(Len(sData(i))), 8)
        Next i
        bb = StrConv(s, vbFromUnicode)
        PropBag.WriteProperty "collDataLens", bb
    Else
        PropBag.WriteProperty "collKeys", bb
        PropBag.WriteProperty "collData", vbNullString
        PropBag.WriteProperty "collDataLens", bb
    End If
    '
    ' And now just write the last index we had specified.
    PropBag.WriteProperty "collIndex", idx, 1
End Sub

Private Sub UserControl_ReadProperties(PropBag As PropertyBag)
    Dim sKeys() As String
    Dim sData() As String
    Dim iDataLens() As Long
    Dim bb() As Byte
    Dim i As Long, j As Long
    Dim s As String
    '
    ' Collections don't support persistence, so we do it the hard way.
    '
    Set coll = Nothing              ' Let's start out fresh.
    '
    ' Fetch keys from property bag.
    bb = PropBag.ReadProperty("collKeys", bb)
    If IsDimmedByte(bb) Then
        ReDim sKeys(UBound(bb) \ 8)
        For i = 0 To UBound(bb) Step 8
            s = Chr$(bb(i + 0)) & Chr$(bb(i + 1)) & Chr$(bb(i + 2)) & Chr$(bb(i + 3)) & Chr$(bb(i + 4)) & Chr$(bb(i + 5)) & Chr$(bb(i + 6)) & Chr$(bb(i + 7))
            sKeys(i \ 8) = CStr(CLng("&h" & s))
        Next i
        Erase bb
        '
        ' Fetch data lengths from property bag.
        bb = PropBag.ReadProperty("collDataLens", bb)
        ReDim iDataLens(UBound(bb) \ 8)
        For i = 0 To UBound(bb) Step 8
            s = Chr$(bb(i + 0)) & Chr$(bb(i + 1)) & Chr$(bb(i + 2)) & Chr$(bb(i + 3)) & Chr$(bb(i + 4)) & Chr$(bb(i + 5)) & Chr$(bb(i + 6)) & Chr$(bb(i + 7))
            iDataLens(i \ 8) = CLng("&h" & s)
        Next i
        Erase bb
        '
        ' Fetch data and parse.
        s = PropBag.ReadProperty("collData", vbNullString)
        ReDim sData(UBound(iDataLens))
        j = 1
        For i = 0 To UBound(iDataLens)
            sData(i) = Mid$(s, j, iDataLens(i))
            j = j + iDataLens(i)
        Next i
        '
        ' And now put it all into the collection.
        For i = 0 To UBound(sKeys) ' Add all to the collection.
            coll.Add sData(i), sKeys(i)
        Next i
    End If
    '
    ' Read the index so we can return to the same one.
    idx = PropBag.ReadProperty("collIndex", 1)
End Sub

Public Property Get collCollection() As Collection
    Set collCollection = coll     ' This returns the entire collection to the user so it can be directly used.
    ' However, be VERY careful here.  It should be used in a read-only mode because this control won't track changes all that well unless made herein.
End Property

Public Property Get collCount() As Long
    collCount = coll.Count
End Property

Public Property Let collCount(i As Long)
    ' It's read only, but we need this so it'll appear in the Property Window.
End Property

Public Property Get collRemove() As Boolean
    collRemove = False
End Property

Public Property Let collRemove(bDelete As Boolean)
    If IsInCollection Then coll.Remove CStr(idx)
End Property

Public Property Get collData() As String
    If IsInCollection Then collData = coll.Item(CStr(idx))
    ' If not found just return "".
End Property

Public Property Let collData(ByVal New_Data As String)
    If IsInCollection Then coll.Remove CStr(idx)
    coll.Add New_Data, CStr(idx)
    PropertyChanged "collData"
End Property

Public Property Get collIndex() As Long
    collIndex = idx
End Property

Public Property Let collIndex(ByVal New_Index As Long)
    idx = New_Index
    PropertyChanged "collIndex"
End Property

Private Function IsInCollection() As Boolean
    On Error GoTo GetOut
    IsObject coll.Item(CStr(idx))
    IsInCollection = True
GetOut:
End Function

Private Function CollKeys() As String()
    ' Returns a string array of all the keys.
    Dim sKeys() As String
    Dim j As Long
    Dim iHold As Long
    Dim ptr As Long
    Dim sKeyTemp  As String
    '
    If coll.Count = 0 Then Exit Function
    '
    ReDim sKeys(coll.Count - 1)
    j = 0
    CopyMemory ptr, ByVal ObjPtr(coll) + &H18, 4                ' First item pointer of collection header.
    GoSub MoveKeyToArray
    For j = 1 To coll.Count - 1
        CopyMemory ptr, ByVal ptr + &H18, 4                     ' Next item pointer of collection item.
        GoSub MoveKeyToArray
    Next j
    CollKeys = sKeys
    Exit Function
    '
MoveKeyToArray: ' j and ptr must be set to call this.
    iHold = StrPtr(sKeyTemp)                                    ' Save string pointer because we're going to borrow the string.
    CopyMemory ByVal VarPtr(sKeyTemp), ByVal ptr + &H10, 4      ' Key string of collection item.
    sKeys(j) = sKeyTemp                                         ' Move key into array.
    CopyMemory ByVal VarPtr(sKeyTemp), iHold, 4                 ' Put string pointer back to keep memory straight.
    Return
End Function

Public Function IsDimmedByte(TheArray() As Byte) As Boolean
    ' This won't fail on one of the (0 to -1) arrays.
    On Error Resume Next
        IsDimmedByte = (LBound(TheArray) = LBound(TheArray)) ' Will error (leaving IsDimmedDbl = False) if not dimensioned.
    On Error GoTo 0
End Function

